// =========================================================================================================
//  Bullet Tracker - (part of the Mobile Target Range module)
//  Author: Kronzky (www.kronzky.info / kronzky@gmail.com)
// =========================================================================================================

KRON_BallisticsChart=[];
titletext["","plain"];
hint "";

_ammo = _this select 4;
_bullet = nearestObject [player, _ammo];
_zASL = (getPosASL _bullet) select 2;
_zPos = (getPos _bullet) select 2;
_zOff = _zASL-_zPos;
_wdir = direction player;
KRON_BallisticsChart set [0,[0,round((_zASL-_zOff)*100)/100]];
if (KRON_Ballistics) then {
	setAccTime .5;
} else {
	setAccTime 1;
};
if (isNull _bullet) exitWith {};
_starttime=time;

_dist=0;
_di=1;
_lastpos=[0,0,0];
_lastpos0=[0,0,0];
if ((KRON_BulletCam>0) && (isNil("KRON_cam"))) then {
	KRON_cam = "camera" camcreate [0,0,0];
	KRON_cam cameraeffect ["internal", "back"];
	setAccTime KRON_BulletCam;
	KRON_cam camSetFocus [2,0];
	
	waitUntil {
		if !(isNull _bullet) then {
			_dist=_bullet distance player; 
			_lastpos=getPos _bullet;
			_bulletdir = getDir _bullet;
			_sindir = sin _bulletdir;
			_cosdir = cos (_bulletdir);
			KRON_cam camsetpos [(_lastpos select 0)-_sindir*1, (_lastpos select 1)-_cosdir*1, ((_lastpos select 2)+.1) max .5]; 
			KRON_cam camsettarget [(_lastpos select 0)+_sindir*100, (_lastpos select 1)+_cosdir*100, ((_lastpos select 2)+.1) max .25]; 
			KRON_cam camcommit 0;
			sleep .0001;
		}; 
		isNull _bullet;
	};
	setAccTime 1;
	sleep 1;
	KRON_cam cameraeffect ["terminate", "back"]; 
	camdestroy KRON_cam;
	KRON_cam=nil;

} else {
	
	waitUntil {
		if !(isNull _bullet) then {
			_dist=_bullet distance player; 
			_lastpos=getPosASL _bullet;
			_lastpos0=getPosASL _bullet;
			_di1=floor(_dist/50)+1;
			_bz=round(((_lastpos select 2)-_zOff)*100)/100;
			if (_di1>_di) then {
				//KRON_BallisticsChart=KRON_BallisticsChart + [[round(_dist),_bz,round((_dist/(time-_starttime))*100)/100]];
				KRON_BallisticsChart=KRON_BallisticsChart + [[round(_dist),_bz]];
				_di=_di1;
			};
			//if (_bz<.1) then {_di=999};
			sleep .0001;
		}; 
		isNull _bullet;
	};
};
player setdamage 0;

_speed=if ((time-_starttime)>0) then {round(_dist/(time-_starttime))} else {0};
if (KRON_BulletCam>0) then {_speed=0};
_bpos=[getPos player, _wdir, 0, _dist] call KRON_rotpoint;
_xoff=round((_lastpos0 distance [_bpos select 0,_bpos select 1,_lastpos0 select 2])*100)/100;

if !(KRON_Ballistics) then {
	KRON_BallisticsChart=nil;
	titletext [format["\n\n\n\n\n\n\n\n\n\n\n\n\n\n[%1] Impact: elev:%2, dist:%3, height:%4, x-off:%5, speed:%6m/sec",fired, KRON_dirshot, floor(_dist),round(((_lastpos select 2)-_zOff)*100)/100,_xoff,_speed],"plain"]; 
} else {
	if (_di!=999) then {
		_di=floor(_dist/50)+1;
		_d=round(_dist);
		_z=round(((_lastpos select 2)-_zOff)*100)/100;
		_lastdist=(KRON_BallisticsChart select ((count KRON_BallisticsChart)-1)) select 0;
		if (_d!=_lastdist) then {
			KRON_BallisticsChart=KRON_BallisticsChart + [[_d,_z]];
		}; 
	};
	createDialog "Dlg1";
	lbClear 52;
	lbAdd [52,format["weapon: %1",fired]];
	_paste=format["weapon: %1|",getText (configFile >> "cfgWeapons" >> fired >> "displayName")];
	lbAdd [52,format["%1",_ammo]];
	_paste=_paste+format["ammo: %1|",_ammo];
	lbAdd [52,format["elevation: %1",KRON_dirshot]];
	_paste=_paste+format["angle: %1|",KRON_dirshot];
	lbAdd [52,format["x-offset: %1",_xoff]];
	_paste=_paste+format["x-offset: %1|",_xoff];
	lbAdd [52,format["speed: %1",_speed]];
	_paste=_paste+format["speed: %1|",_speed];
	{lbAdd [52,format["%1: %2",_x select 0,_x select 1]]; _paste=_paste+format["%1,%2|",_x select 0,_x select 1]}forEach KRON_BallisticsChart;
	//{lbAdd [52,format["%1: %2,%3",_x select 0,_x select 1,_x select 2]]; _paste=_paste+format["%1,%2,%3|",_x select 0,_x select 1,_x select 2]}forEach KRON_BallisticsChart;
	ctrlSetText [53, format["%1",_paste]];	
};
hint "";

if (accTime!=.99) then {setAccTime KRON_SlowMo};

if (KRON_Marker) then {[_lastpos] call KRON_makemarker};